// Global values.
::GLOBALS <-
{
	// Used as a list of victims. It takes three values with the following: Victim player index, time spent in trigger, and if they've begun to take damage.
	PlayersInTrigger = [ ]
}

// Update; this is the main script where we take our information ( from our list ) and use it accordingly.
function Update()
{
	// printf( "Size of PlayersInTrigger array is " + GLOBALS.PlayersInTrigger.len().tostring() + ".\n" )


	// Iterate through each unique property in our list of victims.
	for ( local i = 0; i < GLOBALS.PlayersInTrigger.len(); i += 3 )
	{
		// Our victim.
		local client = PlayerInstanceFromIndex( GLOBALS.PlayersInTrigger[i] )

		if ( !client )
			continue

		// Print information about our victim to the console.
		// printf( Convars.GetClientConvarValue( "name", GLOBALS.PlayersInTrigger[i] ) + " has spent " + GLOBALS.PlayersInTrigger[ i + 1 ] + " second" + ( ( GLOBALS.PlayersInTrigger[ i + 1 ] == 1 ) ? "" : "s" ) + " in danger.\n" )


		// Increment the seconds each victim has spent in danger.
		GLOBALS.PlayersInTrigger[ i + 1 ]++


		// If our victim has spent more than 0 seconds in the trigger, start damaging them.
		if ( GLOBALS.PlayersInTrigger[ i + 1 ] >= 0 )
		{
			// Reflect that they're now in danger; this is used for the healing and sound effects when they're back in safety.
			GLOBALS.PlayersInTrigger[i + 2] = true

			// Damage the victim!
			client.TakeDamage( 25, 16384, self )
		}
	}

	// Update again after a second.
	return 1.0
}

// Adds a victim to the list.
function AddPlayerToList()
{
	GLOBALS.PlayersInTrigger.push( activator.entindex() )

	GLOBALS.PlayersInTrigger.push( 0 )

	GLOBALS.PlayersInTrigger.push( false )
}

// Removes a specific victim from the list.
function RemoveTargetedPlayerFromList( clientIndex )
{
	for ( local i = 0; i < GLOBALS.PlayersInTrigger.len(); i += 3 )
	{
		if ( GLOBALS.PlayersInTrigger[i] == clientIndex )
		{
			GLOBALS.PlayersInTrigger.remove( i )

			local player = PlayerInstanceFromIndex( clientIndex )

			// if ( player.IsAlive() && GLOBALS.PlayersInTrigger[i + 1] )
			// {
				// EmitSoundOnClient( "Healthkit.Touch", player )

				// local HealAmount = ( GLOBALS.PlayersInTrigger[i] * 3 ) - 27

				// player.SetHealth( player.GetHealth() + HealAmount )

				// printf( "Healing " + HealAmount + " health.\n" )
			// }

			GLOBALS.PlayersInTrigger.remove( i )

			GLOBALS.PlayersInTrigger.remove( i )

			break
		}
	}
}

// Removes an activator from the list.
function RemovePlayerFromList()
{
	RemoveTargetedPlayerFromList( activator.entindex() )
}

// Removes a victim from the list if they have disconnected.
function OnGameEvent_player_disconnect( options )
{
	RemoveTargetedPlayerFromList( GetPlayerFromUserID( options.userid ).entindex() )
}

// PrecacheScriptSound( "Healthkit.Touch" )

__CollectGameEventCallbacks(this)
