// This was copy and pasted from the Valve developer community; this is NOT my own thing that I created here.
::PlayerManager <- Entities.FindByClassname(null, "tf_player_manager")
::GetPlayerUserID <- function(player)
{
    return NetProps.GetPropIntArray(PlayerManager, "m_iUserID", player.entindex())
}

// This was also copy and pasted from the Valve developer community; again, this is NOT my own.
function GivePlayerHelmetCosmetic( playerIndex )
{
	local player = PlayerInstanceFromIndex( playerIndex )

	local weapon = Entities.CreateByClassname("tf_weapon_parachute")
	NetProps.SetPropInt(weapon, "m_AttributeManager.m_Item.m_iItemDefinitionIndex", 1101)
	NetProps.SetPropBool(weapon, "m_AttributeManager.m_Item.m_bInitialized", true)
	weapon.SetTeam(player.GetTeam())
	weapon.DispatchSpawn()
	player.Weapon_Equip(weapon)
	local wearable = NetProps.GetPropEntity(weapon, "m_hExtraWearable")
	weapon.Kill()
	
	// NetProps.SetPropInt(wearable, "m_AttributeManager.m_Item.m_iItemDefinitionIndex", 1033)
	NetProps.SetPropInt(wearable, "m_AttributeManager.m_Item.m_iItemDefinitionIndex", 30473)
	NetProps.SetPropBool(wearable, "m_AttributeManager.m_Item.m_bInitialized", true)
	NetProps.SetPropBool(wearable, "m_bValidatedAttachedEntity", true)
	wearable.DispatchSpawn()

	// (optional) Set the model to something new. (Obeys econ's ragdoll physics when ragdolling as well)
	// if (model_path)
	// 	wearable.SetModelSimple(model_path)

	// (optional) recalculates bodygroups on the player
	SendGlobalGameEvent("post_inventory_application", { userid = GetPlayerUserID(player) })

	player.ValidateScriptScope()

	local playerScope = player.GetScriptScope()

	if ( playerScope && !("wearables" in playerScope) )
	{
		playerScope.wearables <- []
	}

	playerScope.wearables.append(wearable)

	return wearable
}




function GivePlayerHelmet( clientIndex )
{
	GivePlayerHelmetCosmetic( clientIndex )
}

// Change this later.
function OnGameEvent_player_spawn( options )
{
	local player = GetPlayerFromUserID( options.userid )



	if ( player )
	{
		player.ValidateScriptScope()

		local playerScope = player.GetScriptScope()

		if ( playerScope )
		{
			if ( !("wearables" in playerScope) )
			{
				playerScope.wearables <- []
			}

			if ( playerScope.wearables.len() < 1 )
			{
				GivePlayerHelmet( player.entindex() )
			}
		}
	}
}

function OnGameEvent_scorestats_accumulated_update( options )
{
	for ( local i = 0; i <= MaxClients().tointeger(); i++ )
	{
		local player = PlayerInstanceFromIndex( i );

		if ( !player )
		{
			continue
		}

		player.ValidateScriptScope()

		local playerScope = player.GetScriptScope()

		if ( playerScope )
		{
			if ( !("wearables" in playerScope) )
			{
				playerScope.wearables <- []
			}

			if ( playerScope.wearables.len() > 0 )
			{
				playerScope.wearables[0].Destroy()
			}

			playerScope.wearables.clear()
		}
	}
}

__CollectGameEventCallbacks(this)